//Modify PONG! settings.
const SEP_COMMANDS = '@'; //Used between multiple commands.
const SEP_COMMAND  = '^'; //Used Between command:message.
const SEP_MESSAGES = '_'; //Used internally between messages.
const SEP_MESSAGE  = '+'; //Used internally in 1 message.

const MSG_LOGIN = "*Logged in...*";
const MSG_LOGOUT = "*Logged out...*";
const MSG_PLAYSAGAINST = "*Plays against";

var settingsObserver =
{
	observe: function(subject, topic, state)
	{
		if (topic == "pong-close" && state == 'OK') if (window) window.close();
	}
}

var oSchemeText1Red;
var oSchemeText1Green;
var oSchemeText1Blue;
var oSchemeBack1Red;
var oSchemeBack1Green;
var oSchemeBack1Blue;
var oSchemeText2Red;
var oSchemeText2Green;
var oSchemeText2Blue;
var oSchemeBack2Red;
var oSchemeBack2Green;
var oSchemeBack2Blue;
var oSchemeText3Red;
var oSchemeText3Green;
var oSchemeText3Blue;
var oSchemeBack3Red;
var oSchemeBack3Green;
var oSchemeBack3Blue;

var oTemplate5;
var oTemplate6;
var oTemplate7;
var oTemplate8;
var oTemplate9;

var aDirectPlayFriends = new Array;
var aKeycodes = new Array ([65, "A"],[66, "B"],[67, "C"],[68, "D"],[69, "E"],[70, "F"],[71, "G"],[72, "H"],[73, "I"],[74, "J"],[75, "K"],[76, "L"],[77, "M"],[78, "N"],[79, "O"],[80, "P"],[81, "Q"],[82, "R"],[83, "S"],[84, "T"],[85, "U"],[86, "V"],[87, "W"],[88, "X"],[89, "Y"],[90, "Z"],[13, "ENTER"],[16, "SHIFT"],[17, "CTRL"],[18, "ALT"],[32, "SPACE"],[37, "Left"],[38, "Up"],[39, "Right"],[40, "Down"],[97, "Num 1"],[98, "Num 2"],[99, "Num 3"],[100, "Num 4"],[101, "Num 5"],[102, "Num 6"],[103, "Num 7"],[104, "Num 8"],[105, "Num 9"]);

var sCurrentColorScheme = "default";

var iP1KeyUp;
var iP1KeyDown;
var iP1KeyStart;
var iP2KeyUp;
var iP2KeyDown;
var iP2KeyStart;

var bNotify = false;

function InitWindow()
{
	this.resizeTo(600,415);
	document.title = "PONG! Settings";

	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService)
	oObService.addObserver(settingsObserver, "pong-close", false); 
	
	InitPONGPreferences();
	
	//Color schemes...
	oSchemeText1Red = document.getElementById('tbschemetext1red');
	oSchemeText1Green = document.getElementById('tbschemetext1green');
	oSchemeText1Blue = document.getElementById('tbschemetext1blue');
	oSchemeBack1Red = document.getElementById('tbschemeback1red');
	oSchemeBack1Green = document.getElementById('tbschemeback1green');
	oSchemeBack1Blue = document.getElementById('tbschemeback1blue');
	oSchemeText2Red = document.getElementById('tbschemetext2red');
	oSchemeText2Green = document.getElementById('tbschemetext2green');
	oSchemeText2Blue = document.getElementById('tbschemetext2blue');
	oSchemeBack2Red = document.getElementById('tbschemeback2red');
	oSchemeBack2Green = document.getElementById('tbschemeback2green');
	oSchemeBack2Blue = document.getElementById('tbschemeback2blue');
	oSchemeText3Red = document.getElementById('tbschemetext3red');
	oSchemeText3Green = document.getElementById('tbschemetext3green');
	oSchemeText3Blue = document.getElementById('tbschemetext3blue');
	oSchemeBack3Red = document.getElementById('tbschemeback3red');
	oSchemeBack3Green = document.getElementById('tbschemeback3green');
	oSchemeBack3Blue = document.getElementById('tbschemeback3blue');

	DisplayColorValues();
	
	//Chat templates...
	oTemplate5 = document.getElementById('tbkey5');
	oTemplate6 = document.getElementById('tbkey6');
	oTemplate7 = document.getElementById('tbkey7');
	oTemplate8 = document.getElementById('tbkey8');
	oTemplate9 = document.getElementById('tbkey9');
	
	oTemplate5.value = GetPreferenceString('chattemplate5');
	oTemplate6.value = GetPreferenceString('chattemplate6');
	oTemplate7.value = GetPreferenceString('chattemplate7');
	oTemplate8.value = GetPreferenceString('chattemplate8');
	oTemplate9.value = GetPreferenceString('chattemplate9');

	//Direct Play Friends...
	LoadDirectPlayFriends();
	
	//General...
	document.getElementById("soundeffects").checked = GetPreferenceBool("soundon");
	document.getElementById("attentiononlogin").checked = GetPreferenceBool("attentiononlogin");
	document.getElementById("playonlan").checked = GetPreferenceBool("playonlan");
	document.getElementById("displaytooltips").checked = GetPreferenceBool("displaytooltips");
	document.getElementById("keyboardacceleration").checked = GetPreferenceBool("keyboardacceleration");

	document.getElementById("timedport").value = GetPreferenceInt("timedport");
	document.getElementById("loopport").value = GetPreferenceInt("loopport");
	
	LoadShortcut()
	SetKeyboardMoveKeys();
	
	//Apply colors...
	var oML = document.getElementById('mlsettingscolorselect');
	var sID = GetPreferenceString("colorscheme");
	var oMItem = document.getElementById(sID);

	oML.selectedItem = oMItem;
	ProcessColorSelect(sID);
	
	bNotify = true;
}

function CloseWindow()
{
	var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
	oObService.removeObserver(settingsObserver, "pong-close"); 

	settingsObserver = null;
}

//Direct Play Friends.
function AddNewDirectPlayFriend()
{
	var sNickName = document.getElementById('tbdpnickname').value;
	var sIPAddress = document.getElementById('tbdpipaddress').value;
	
	if (IsValidString(sNickName) == false) return MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the nickname.');
	if (IsIPAddress(sIPAddress) == false) return MessageBox('The IP Address entered does not appear to be a valid one.\nPlease use a [123.123.123.123] format.');
	
	AddDirectPlayFriend(sIPAddress, sNickName);
	document.getElementById('tbdpnickname').value = "";
	document.getElementById('tbdpipaddress').value = "";
	SaveDirectPlayFriends();
	LoadDirectPlayFriends();
}

function LoadDirectPlayFriends()
{
	var sFriends = GetPreferenceString("directplayfriends");
	var aFriends, aFriend;
	var iIndex, iLen;
	
	ClearDirectPlayList();
	
	if (sFriends != '')
	{
		aFriends = sFriends.split(SEP_MESSAGES);
		iLen = aFriends.length;
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			aFriend = aFriends[iIndex].split(SEP_MESSAGE);
			AddDirectPlayFriend(aFriend[0], aFriend[1]);
		}
	}
}

function AddDirectPlayFriend(sIPAddress, sNickName)
{
	var oVB = document.getElementById('vbdirectplayfriends');
	var oHBox, oLabelNick, oLabelIP, oTBNick, oTBIP, oButtonDelete;
	var iLen = aDirectPlayFriends.length;
	var iIndex;
	var bFound = false;

	//Check for duplicates.
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (aDirectPlayFriends[iIndex][0] == sIPAddress && aDirectPlayFriends[iIndex][1] == sNickName) bFound = true;
	}
	
	if (bFound == false)
	{
		aDirectPlayFriends[iLen] = new Array(sIPAddress, sNickName);

		oHBox = document.createElement('hbox');

		oLabelNick = document.createElement('label');
		oLabelNick.setAttribute('value', 'Nickname: ');
		oLabelNick.style.marginTop = '6px';
		oLabelNick.style.marginRight = 0;
		oHBox.appendChild(oLabelNick);
		
		oTBNick = document.createElement('textbox');
		oTBNick.id = 'idnick' + iLen;
		oTBNick.setAttribute('value', sNickName);
		oTBNick.setAttribute('maxlength', 20);
		oTBNick.setAttribute('maxwidth', 160);
		oHBox.appendChild(oTBNick);
		
		oLabelIP = document.createElement('label');
		oLabelIP.setAttribute('value', 'IP Address: ');
		oLabelIP.style.marginTop = '6px';
		oLabelIP.style.marginRight = 0;
		oHBox.appendChild(oLabelIP);
		
		oTBIP = document.createElement('textbox');
		oTBIP.id = 'idip' + iLen;
		oTBIP.setAttribute('value', sIPAddress);
		oTBIP.setAttribute('maxlength', 20);
		oTBIP.setAttribute('maxwidth', 130);
		oHBox.appendChild(oTBIP);

		oButtonDelete = document.createElement('button');
		oButtonDelete.setAttribute('label', 'Delete');
		oButtonDelete.setAttribute("oncommand", "DeleteDirectPlayFriend('" + iLen + "')");
		oButtonDelete.style.marginTop = '1px';
		oHBox.appendChild(oButtonDelete);

		oVB.insertBefore(oHBox, oVB.firstChild);
		ApplyColorScheme(oVB);
	}
}

function DeleteDirectPlayFriend(iIndex)
{
	aDirectPlayFriends.splice(iIndex, 1);
	SaveDirectPlayFriends();
	LoadDirectPlayFriends();
}

function SaveModifiedDirectPlayFriends()
{
	var sValue;
	var iIndex, iLen;

	iLen = aDirectPlayFriends.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		sValue = document.getElementById('idnick' + iIndex).value;
		if (sValue != aDirectPlayFriends[iIndex][1]) aDirectPlayFriends[iIndex][1] = sValue;
		sValue = document.getElementById('idip' + iIndex).value;
		if (sValue != aDirectPlayFriends[iIndex][0]) aDirectPlayFriends[iIndex][0] = sValue;
	}
	SaveDirectPlayFriends();
}

function SaveDirectPlayFriends()
{
	var sFriends = "";
	var iIndex, iLen;
	
	iLen = aDirectPlayFriends.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (aDirectPlayFriends[iIndex][0] != '')
		{
			sFriends += aDirectPlayFriends[iIndex][0] + SEP_MESSAGE + aDirectPlayFriends[iIndex][1] + SEP_MESSAGES;
		}
	}
	sFriends = sFriends.substring(0, sFriends.length - 1); //Remove last SEP_MESSAGES
	SetPreferenceString("directplayfriends", sFriends);
	
	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-directplayfriends", "OK");
	}
}

function ClearDirectPlayList()
{
	var oVB = document.getElementById('vbdirectplayfriends');
	var oChild;
	var iIndex, iLen;
	
	aDirectPlayFriends = null;
	aDirectPlayFriends = new Array;
	
	iLen = oVB.childNodes.length - 1;
	
	for (iIndex = iLen; iIndex >= 0; iIndex --)
	{
		oChild = oVB.childNodes[iIndex];
		oVB.removeChild(oChild);
	}
}

//Chat templates.
function SaveTemplates()
{
	var sTemplate5, sTemplate6, sTemplate7, sTemplate8, sTemplate9;
	var bSave = true;
	
	sTemplate5 = oTemplate5.value;
	sTemplate6 = oTemplate6.value;
	sTemplate7 = oTemplate7.value;
	sTemplate8 = oTemplate8.value;
	sTemplate9 = oTemplate9.value;

	if (IsValidString(sTemplate5) == false)
	{
		oTemplate5.value = GetPreferenceString("chattemplate5");
		bSave = false;
	}
	if (IsValidString(sTemplate6) == false)
	{
		oTemplate6.value = GetPreferenceString("chattemplate6");
		bSave = false;
	}
	if (IsValidString(sTemplate7) == false)
	{
		oTemplate7.value = GetPreferenceString("chattemplate7");
		bSave = false;
	}
	if (IsValidString(sTemplate8) == false)
	{
		oTemplate8.value = GetPreferenceString("chattemplate8");
		bSave = false;
	}
	if (IsValidString(sTemplate9) == false)
	{
		oTemplate9.value = GetPreferenceString("chattemplate9");
		bSave = false;
	}

	if (bSave == false) return MessageBox('The [ ' + SEP_COMMANDS + ' ], [ ' + SEP_COMMAND + ' ], [ ' + SEP_MESSAGES + ' ], [ ' + SEP_MESSAGE + ' ] and [\\n] characters are not allowed in the templates.\nAs wel as the system login, logout and plays against messages.');

	SetPreferenceString("chattemplate5", sTemplate5)
	SetPreferenceString("chattemplate6", sTemplate6)
	SetPreferenceString("chattemplate7", sTemplate7)
	SetPreferenceString("chattemplate8", sTemplate8)
	SetPreferenceString("chattemplate9", sTemplate9)

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-chattemplate", "OK");
	}
}

function IsValidString(sValue)
{
	if (sValue.indexOf(SEP_COMMANDS) >= 0 || sValue.indexOf(SEP_COMMAND) >= 0 || sValue.indexOf(SEP_MESSAGES) >= 0 || sValue.indexOf(SEP_MESSAGE) >= 0 || HasEscapeChar(sValue) == true) return false;
	if (sValue.substr(0, MSG_PLAYSAGAINST.length) == MSG_PLAYSAGAINST) return false;
	if (sValue == MSG_LOGIN || sValue == MSG_LOGOUT) return false;
	return true;
}

function HasEscapeChar(sValue)
{
	var iIndex, iLen;
	
	iLen = sValue.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (sValue.charCodeAt(iIndex) == 92 && (sValue.charCodeAt(iIndex + 1) == 110 || sValue.charCodeAt(iIndex + 1) == 78)) return true;
	}
	return false;
}

//Color schemes...
function ProcessColorSelect(sID)
{
	var oWindow = document.getElementById('pong-settings');

	oWindow.className = 'main_' + sID;
	
	if (sID == 'default') sCurrentColorScheme = 'default';
	if (sID == 'red') sCurrentColorScheme = '1';
	if (sID == 'green') sCurrentColorScheme = '2';
	if (sID == 'blue') sCurrentColorScheme = '3';
	
	oWindow.style.backgroundColor = "rgb(" + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "blue") + ")";
	oWindow.style.color = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";

	//Save it.
	SetPreferenceString("colorscheme", sID);
	
	//Apply it.
	ApplyColor();
}

function DisplayColorValues()
{
	document.getElementById("rgschemeball1").selectedItem = document.getElementById("r1" + GetPreferenceString("colorschemeobjects1"));
	document.getElementById("rgschemeball2").selectedItem = document.getElementById("r2" + GetPreferenceString("colorschemeobjects2"));
	document.getElementById("rgschemeball3").selectedItem = document.getElementById("r3" + GetPreferenceString("colorschemeobjects3"));

	oSchemeText1Red.value = GetPreferenceInt("colorschemetext1red");
	oSchemeText1Green.value = GetPreferenceInt("colorschemetext1green");
	oSchemeText1Blue.value = GetPreferenceInt("colorschemetext1blue");
	oSchemeBack1Red.value = GetPreferenceInt("colorschemeback1red");
	oSchemeBack1Green.value = GetPreferenceInt("colorschemeback1green");
	oSchemeBack1Blue.value = GetPreferenceInt("colorschemeback1blue");
	oSchemeText2Red.value = GetPreferenceInt("colorschemetext2red");	
	oSchemeText2Green.value = GetPreferenceInt("colorschemetext2green");
	oSchemeText2Blue.value = GetPreferenceInt("colorschemetext2blue");
	oSchemeBack2Red.value = GetPreferenceInt("colorschemeback2red");
	oSchemeBack2Green.value = GetPreferenceInt("colorschemeback2green");
	oSchemeBack2Blue.value = GetPreferenceInt("colorschemeback2blue");
	oSchemeText3Red.value = GetPreferenceInt("colorschemetext3red");
	oSchemeText3Green.value = GetPreferenceInt("colorschemetext3green");
	oSchemeText3Blue.value = GetPreferenceInt("colorschemetext3blue");
	oSchemeBack3Red.value = GetPreferenceInt("colorschemeback3red");
	oSchemeBack3Green.value = GetPreferenceInt("colorschemeback3green");
	oSchemeBack3Blue.value = GetPreferenceInt("colorschemeback3blue");
}

function ResetColorDefaults()
{
	var bResult = confirm('This will reset all color schemes to their original values, all your changes will be lost.\n Press [OK] to reset, or press [Cancel] to keep your changes.');
	if (bResult == true)
	{
		SetPreferenceString("colorschemeobjects1", "red"); 
		SetPreferenceString("colorschemeobjects2", "green"); 
		SetPreferenceString("colorschemeobjects3", "blue"); 

		SetPreferenceInt("colorschemetext1red", 255);
		SetPreferenceInt("colorschemetext1green", 64);
		SetPreferenceInt("colorschemetext1blue", 64);
		SetPreferenceInt("colorschemeback1red", 10);
		SetPreferenceInt("colorschemeback1green", 50);
		SetPreferenceInt("colorschemeback1blue", 110);
		SetPreferenceInt("colorschemetext2red", 9);
		SetPreferenceInt("colorschemetext2green", 189);
		SetPreferenceInt("colorschemetext2blue", 9);
		SetPreferenceInt("colorschemeback2red", 170);
		SetPreferenceInt("colorschemeback2green", 50);
		SetPreferenceInt("colorschemeback2blue", 10);
		SetPreferenceInt("colorschemetext3red", 64);
		SetPreferenceInt("colorschemetext3green", 64);
		SetPreferenceInt("colorschemetext3blue", 255);
		SetPreferenceInt("colorschemeback3red", 10);
		SetPreferenceInt("colorschemeback3green", 60);
		SetPreferenceInt("colorschemeback3blue", 10);
		
		ApplyColor();	
		DisplayColorValues();
	}
}

function SaveColor()
{
	SaveColorValues();	
	ApplyColor();	
}

function SaveColorValues()
{
	var sSchemeObjects1 = document.getElementById('rgschemeball1').selectedItem.id;
	var sSchemeObjects2 = document.getElementById('rgschemeball2').selectedItem.id;
	var sSchemeObjects3 = document.getElementById('rgschemeball3').selectedItem.id;
	
	var iSchemeText1Red = Math.max(0, parseInt(oSchemeText1Red.value));
	var iSchemeText1Green = Math.max(0, parseInt(oSchemeText1Green.value));
	var iSchemeText1Blue = Math.max(0, parseInt(oSchemeText1Blue.value));
	var iSchemeBack1Red = Math.max(0, parseInt(oSchemeBack1Red.value));
	var iSchemeBack1Green = Math.max(0, parseInt(oSchemeBack1Green.value));
	var iSchemeBack1Blue = Math.max(0, parseInt(oSchemeBack1Blue.value));
	var iSchemeText2Red = Math.max(0, parseInt(oSchemeText2Red.value));
	var iSchemeText2Green = Math.max(0, parseInt(oSchemeText2Green.value));
	var iSchemeText2Blue = Math.max(0, parseInt(oSchemeText2Blue.value));
	var iSchemeBack2Red = Math.max(0, parseInt(oSchemeBack2Red.value));
	var iSchemeBack2Green = Math.max(0, parseInt(oSchemeBack2Green.value));
	var iSchemeBack2Blue = Math.max(0, parseInt(oSchemeBack2Blue.value));
	var iSchemeText3Red = Math.max(0, parseInt(oSchemeText3Red.value));
	var iSchemeText3Green = Math.max(0, parseInt(oSchemeText3Green.value));
	var iSchemeText3Blue = Math.max(0, parseInt(oSchemeText3Blue.value));
	var iSchemeBack3Red = Math.max(0, parseInt(oSchemeBack3Red.value));
	var iSchemeBack3Green = Math.max(0, parseInt(oSchemeBack3Green.value));
	var iSchemeBack3Blue = Math.max(0, parseInt(oSchemeBack3Blue.value));
	var bSave = true;
	
	if (iSchemeText1Red > 255 || iSchemeText1Green > 255 || iSchemeText1Blue > 255)
	{
		oSchemeText1Red.value = GetPreferenceInt("colorschemetext1red");
		oSchemeText1Green.value = GetPreferenceInt("colorschemetext1green");
		oSchemeText1Blue.value = GetPreferenceInt("colorschemetext1blue");
		bSave = false;
	}
	if (iSchemeBack1Red > 255 || iSchemeBack1Green > 255 || iSchemeBack1Blue > 255)
	{
		oSchemeBack1Red.value = GetPreferenceInt("colorschemeback1red");
		oSchemeBack1Green.value = GetPreferenceInt("colorschemeback1red");
		oSchemeBack1Blue.value = GetPreferenceInt("colorschemeback1green");
		bSave = false;
	}
	if (iSchemeText2Red > 255 || iSchemeText2Green > 255 || iSchemeText2Blue > 255)
	{
		oSchemeText2Red.value = GetPreferenceInt("colorschemetext2red");	
		oSchemeText2Green.value = GetPreferenceInt("colorschemetext2green");
		oSchemeText2Blue.value = GetPreferenceInt("colorschemetext2blue");
		bSave = false;
	}
	if (iSchemeBack2Red > 255 || iSchemeBack2Green > 255 || iSchemeBack2Blue > 255)
	{
		oSchemeBack2Red.value = GetPreferenceInt("colorschemeback2red");
		oSchemeBack2Green.value = GetPreferenceInt("colorschemeback2green");
		oSchemeBack2Blue.value = GetPreferenceInt("colorschemeback2blue");
		bSave = false;
	}
	if (iSchemeText3Red > 255 || iSchemeText3Green > 255 || iSchemeText3Blue > 255)
	{
		oSchemeText3Red.value = GetPreferenceInt("colorschemetext3red");
		oSchemeText3Green.value = GetPreferenceInt("colorschemetext3green");
		oSchemeText3Blue.value = GetPreferenceInt("colorschemetext3blue");
		bSave = false;
	}
	if (iSchemeBack3Red > 255 || iSchemeBack3Green > 255 || iSchemeBack3Blue > 255)
	{
		oSchemeBack3Red.value = GetPreferenceInt("colorschemeback3red");
		oSchemeBack3Green.value = GetPreferenceInt("colorschemeback3green");
		oSchemeBack3Blue.value = GetPreferenceInt("colorschemeback3blue");
		bSave = false;
	}

	if (bSave == false) return MessageBox('Please enter a value between 1-255.');

	sSchemeObjects1 = sSchemeObjects1.substring(2, sSchemeObjects1.length);
	sSchemeObjects2 = sSchemeObjects2.substring(2, sSchemeObjects2.length);
	sSchemeObjects3 = sSchemeObjects3.substring(2, sSchemeObjects3.length);

	SetPreferenceString("colorschemeobjects1", sSchemeObjects1); 
	SetPreferenceString("colorschemeobjects2", sSchemeObjects2); 
	SetPreferenceString("colorschemeobjects3", sSchemeObjects3); 

	SetPreferenceInt("colorschemetext1red", iSchemeText1Red);       
	SetPreferenceInt("colorschemetext1green", iSchemeText1Green);   
	SetPreferenceInt("colorschemetext1blue", iSchemeText1Blue);     
	SetPreferenceInt("colorschemeback1red", iSchemeBack1Red);       
	SetPreferenceInt("colorschemeback1green", iSchemeBack1Green);     
	SetPreferenceInt("colorschemeback1blue", iSchemeBack1Blue);    
	SetPreferenceInt("colorschemetext2red", iSchemeText2Red);       
	SetPreferenceInt("colorschemetext2green", iSchemeText2Green);   
	SetPreferenceInt("colorschemetext2blue", iSchemeText2Blue);     
	SetPreferenceInt("colorschemeback2red", iSchemeBack2Red);       
	SetPreferenceInt("colorschemeback2green", iSchemeBack2Green);   
	SetPreferenceInt("colorschemeback2blue", iSchemeBack2Blue);     
	SetPreferenceInt("colorschemetext3red", iSchemeText3Red);       
	SetPreferenceInt("colorschemetext3green", iSchemeText3Green);   
	SetPreferenceInt("colorschemetext3blue", iSchemeText3Blue);     
	SetPreferenceInt("colorschemeback3red", iSchemeBack3Red);       
	SetPreferenceInt("colorschemeback3green", iSchemeBack3Green);   
	SetPreferenceInt("colorschemeback3blue", iSchemeBack3Blue);     
}

function ApplyColor()
{
	var oWindow = document.getElementById('pong-settings');

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-colorscheme", "OK");
	}

	oWindow.style.backgroundColor = "rgb(" + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "blue") + ")";
	oWindow.style.color = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";

	ApplyColorScheme(oWindow);
}

function ApplyColorScheme(parentObject)
{
	var oChild;
	var iIndex, iLen;
	
	iLen = parentObject.childNodes.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		oChild = parentObject.childNodes[iIndex];
		
		oChild.style.backgroundColor = "rgb(" + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemeback" + sCurrentColorScheme + "blue") + ")";
		oChild.style.color = "rgb(" + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "red") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "green") + "," + GetPreferenceInt("colorschemetext" + sCurrentColorScheme + "blue") + ")";
		if (oChild.childNodes && oChild.childNodes.length > 0) ApplyColorScheme(oChild);
	}
}

//General settings...

function SetKeyboardMoveKeys()
{
	iP1KeyUp = GetPreferenceInt("player1keyup");
	iP1KeyDown = GetPreferenceInt("player1keydown");
	iP1KeyStart = GetPreferenceInt("player1keystart");
	iP2KeyUp = GetPreferenceInt("player2keyup");
	iP2KeyDown = GetPreferenceInt("player2keydown");
	iP2KeyStart = GetPreferenceInt("player2keystart");
	
	ShowDisplayKey(document.getElementById('tkeyp1up'), iP1KeyUp);
	ShowDisplayKey(document.getElementById('tkeyp1down'), iP1KeyDown);
	ShowDisplayKey(document.getElementById('tkeyp1start'), iP1KeyStart);
	ShowDisplayKey(document.getElementById('tkeyp2up'), iP2KeyUp);
	ShowDisplayKey(document.getElementById('tkeyp2down'), iP2KeyDown);
	ShowDisplayKey(document.getElementById('tkeyp2start'), iP2KeyStart);
}

function ShowDisplayKey(oTB, iKeyCode)
{
	var iIndex, iLen;
	var bIsValid = false;
	
	iKeyCode = parseInt(iKeyCode);
	
	iLen = aKeycodes.length;
	for (iIndex = 0; iIndex < iLen; iIndex ++)
	{
		if (aKeycodes[iIndex][0] == iKeyCode)
		{
			oTB.value = aKeycodes[iIndex][1];
			bIsValid = true;
			break;
		}
	}
	
	if (bIsValid == false)
	{
		ShowDisplayKey(document.getElementById('tkeyp1up'), iP1KeyUp);
		ShowDisplayKey(document.getElementById('tkeyp1down'), iP1KeyDown);
		ShowDisplayKey(document.getElementById('tkeyp1start'), iP1KeyStart);
		ShowDisplayKey(document.getElementById('tkeyp2up'), iP2KeyUp);
		ShowDisplayKey(document.getElementById('tkeyp2down'), iP2KeyDown);
		ShowDisplayKey(document.getElementById('tkeyp2start'), iP2KeyStart);
	}
	else
	{
		if (oTB.id == 'tkeyp1up') iP1KeyUp = iKeyCode;
		if (oTB.id == 'tkeyp1down') iP1KeyDown = iKeyCode;
		if (oTB.id == 'tkeyp1start') iP1KeyStart = iKeyCode;
		if (oTB.id == 'tkeyp2up') iP2KeyUp = iKeyCode;
		if (oTB.id == 'tkeyp2down') iP2KeyDown = iKeyCode;
		if (oTB.id == 'tkeyp2start') iP2KeyStart = iKeyCode;
	}

}

function SaveKeyboardMoveKeys()
{
	SetPreferenceInt("player1keyup", iP1KeyUp);
	SetPreferenceInt("player1keydown", iP1KeyDown);
	SetPreferenceInt("player1keystart", iP1KeyStart);
	SetPreferenceInt("player2keyup", iP2KeyUp);
	SetPreferenceInt("player2keydown", iP2KeyDown);
	SetPreferenceInt("player2keystart", iP2KeyStart);
	
	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-keyboardmovekeys", "OK");
	}
}

function SavePorts()
{ 
	var iPort = 0;
	
	iPort = parseInt(document.getElementById("timedport").value);
	if (!iPort || iPort == 21 || iPort == 23 || iPort == 25 || iPort == 80 || iPort == 110)
	{
		iPort = 10997;
		document.getElementById("timedport").value = iPort;		
		MessageBox("Please enter a valid port number, and keep in mind that ports 21, 23, 25, 80 and 110 are already reserved by other services.")
	}
	SetPreferenceInt("timedport", iPort);
	
	iPort = parseInt(document.getElementById("loopport").value);
	if (!iPort || iPort == 21 || iPort == 23 || iPort == 25 || iPort == 80 || iPort == 110)
	{
		iPort = 10998;
		document.getElementById("loopport").value = iPort;
		MessageBox("Please enter a valid port number, and keep in mind that ports 21, 23, 25, 80 and 110 are already reserved by other services.")
	}
	SetPreferenceInt("loopport", iPort);
	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-ports", "OK");
	}
}

function SwitchSound()
{
	var bSoundOn = document.getElementById("soundeffects").checked;
	SetPreferenceBool("soundon", bSoundOn);

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-sound", "OK");
	}
}

function SwitchKeyboardAcceleration()
{
	var bKeyboardAccel = document.getElementById("keyboardacceleration").checked;
	SetPreferenceBool("keyboardacceleration", bKeyboardAccel);

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-keyboardaccel", "OK");
	}
}

function SwitchAttention()
{
	var bAttentionOnLogin = document.getElementById("attentiononlogin").checked;
	SetPreferenceBool("attentiononlogin", bAttentionOnLogin);

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-attention", "OK");
	}
}

function SwitchPlayonLAN()
{
	var bPlayOnLAN = document.getElementById("playonlan").checked;
	SetPreferenceBool("playonlan", bPlayOnLAN);

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-playonlan", "OK");
	}
}

function SwitchDisplayTooltips()
{
	var bDisplayTooltips = document.getElementById("displaytooltips").checked;
	SetPreferenceBool("displaytooltips", bDisplayTooltips);

	if (bNotify == true)
	{
		var oObService = Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
		oObService.notifyObservers(opener, "apply-displaytooltips", "OK");
	}
}

function LoadShortcut()
{
	var sMod = GetPreferenceString("shortcutmodifier");
	var sKey = GetPreferenceString("shortcutkey");

	document.getElementById('ccontrol').checked = (sMod.indexOf('control') >= 0);	
	document.getElementById('cshift').checked = (sMod.indexOf('shift') >= 0);	
	document.getElementById('calt').checked = (sMod.indexOf('alt') >= 0);	
	document.getElementById('tkey').value = sKey;
}

function ModifyShortcut()
{
	var sKey = document.getElementById('tkey').value;
	var sMod = "";
	
	if (document.getElementById('ccontrol').checked == true) sMod += "control ";
	if (document.getElementById('cshift').checked == true) sMod += "shift ";
	if (document.getElementById('calt').checked == true) sMod += "alt ";
	
	SetPreferenceString("shortcutmodifier", sMod);
	SetPreferenceString("shortcutkey", sKey);
}

function IsIPAddress(sValue)
{
	var aValue = sValue.split('.');
	var iIndex, iLen;
	var bRet = false;

	iLen = aValue.length;
	if (iLen == 4)
	{
		for (iIndex = 0; iIndex < iLen; iIndex ++)
		{
			if (parseInt(aValue[iIndex]) >= 0) bRet = true;
			if (bRet == false) return false;
		}
	}
	return bRet;
}

function MessageBox(sText)
{
	alert(sText + '\nVisit http://www.captaincaveman.nl/forum/ for more information and help');
}

